#include "qserver.h"
#include <sys/time.h>

void link_receive () ;


int do_filer (buffer, in_ptr)
char *buffer ;
int  *in_ptr ;

/* 
'buffer' is the main buffer. On entry it contains the header just
read from the link.  'in_ptr' is an (int) pointer
into this buffer, pointing to the next word to be read from
the header.

On exit 'buffer' contains the data to be returned to the link.
The return value of 'do_filer' is the number of bytes of this data.

A negative return value indicates an irrecoverable error.
*/

{
  int *out_ptr = (int *) buffer ;
  switch (*(in_ptr++))
  {
    case tf_open :
    {
      int flags    = *(in_ptr++) ;
      int mode     = *(in_ptr++) ;
      int path_len = *(in_ptr++) ;
      char *path   = (char *) in_ptr ;
      int result ;

      path [path_len] = '\0' ;
      result = open (path, flags, mode) ;

      *(out_ptr++) = f_filer   ;
      *(out_ptr++) = ff_result ;
      *(out_ptr++) = result    ;
      return ((char *) out_ptr) - buffer ;
    }
    case tf_close :
    {
      int descriptor = *(in_ptr++) ;
      int result ;

      result = close (descriptor) ;

      *(out_ptr++) = f_filer   ;
      *(out_ptr++) = ff_result ;
      *(out_ptr++) = result    ;
      return ((char *) out_ptr) - buffer ;
    }
    case tf_get :
    {
      int num_bytes   = *(in_ptr++) ;
      int descriptor  = *(in_ptr++) ;
      int destination = *(in_ptr++) ;
      int *result_field ;
      char *data_field  ;
  
      *(out_ptr++) = f_filer     ;
      *(out_ptr++) = ff_put      ;
      result_field = out_ptr++   ;
      *(out_ptr++) = destination ;
      data_field   = (char *) out_ptr ;

      if ((*result_field = read (descriptor, data_field, num_bytes)) > 0)
        return (data_field + *result_field) - buffer ;
      else
        return ((char *) (++result_field)) - buffer ;
    }
    case tf_put :
    {
      int num_bytes    = *(in_ptr++) ;
      int descriptor   = *(in_ptr++) ;
      char *data_field = (char *) in_ptr ;
      int header_data_len = WRITE_HEADER_SIZE - (data_field - buffer) ;
      int result ;

      if (header_data_len < num_bytes)
      {
        link_receive (data_field + header_data_len, num_bytes - header_data_len) ;
      }
      result = write (descriptor, data_field, num_bytes) ;

      *(out_ptr++) = f_filer   ;
      *(out_ptr++) = ff_result ;
      *(out_ptr++) = result    ;
      return ((char *) out_ptr) - buffer ;
    }
    default :
    {
      printf ("Unknown filer tag: %d.\n", *(--in_ptr)) ;
      return -1 ;
    }
  }
}
/*
--
--     End of File.
--
*/
